#include <iostream>
#include <iomanip>
#include <string>
#include <list>
#include <map>
#include <algorithm>

using namespace std;

typedef map<string, int> Table;

struct WordCounts {
	string word;
	unsigned count;

	WordCounts(): count(0)  {}

	WordCounts (string w, unsigned c) : word(w), count(c) {}

	//sobrecarga del operador <
	bool operator< (const WordCounts& wc) {
		if (count > wc.count)
			return true;
		else if (count == wc.count)
			return (word < wc.word);
		else
		return false;
	}
};


typedef list<WordCounts> Concordance;

void main () {
	const char UpperToLower = 'a' - 'A';
	Table words;

	cout<<endl<<"Escriba un texto, para terminar presione <enter> y luego <ctrl> + <d>"<<endl;
	while (cin) {
		string w;
		char c;
		do {  //se transforma la palabra a minusculas.
			cin.get(c);
			if ((c >= 'A') && (c <= 'Z'))
			c += UpperToLower;
			if ((c >= 'a') && (c <= 'z'))
			w += c;
		}
		while ((cin) && ((c >= 'a') && (c <= 'z')));

		//se agraga la palabra al mapa, si ya existe, se
		//aumenta el contador.
		if (w.size() > 0) {
			words[w]++;
		}
	}

	Concordance concord;
	//iterador para el mapa.
	map<string, int>::iterator indice = words.begin();

	//palabras copiadas desde el mapa a la lista para ordenarlas.
	do {
		concord.push_back( WordCounts ( (*indice).first,(*indice).second ) );
		indice++;
	}while(indice!=words.end());

    // ordena concord en orden descendiente por count.
	concord.sort();

	//crea un iterador para concord.
	Concordance::iterator Lindex = concord.begin();

	//despliega el resultado en pantalla.
	cout<<endl;
	cout<<" Ocurrecias | Palabra"<<endl;
	cout<<"----------------------------"<<endl;
	while(Lindex != concord.end()) {
		cout<<setw(7)<<Lindex->count<<"     |  "<<Lindex->word<<endl;
		Lindex++;
	}


	exit(0);
}
